/*jshint esversion: 6 */

Template.materializeTimePickerModal.onRendered(() => {
  const instance = Template.instance();
  const modalId = '#'+instance.data.id;

  //init the modal
  jQuery(modalId).leanModal({

    //when modal is opened
    ready: (modal, trigger) => {

      //render the picker in modal content
      const modalContentNode = $(modalId).find('.modal-content').get(0);
      Blaze.renderWithData(Template.materializeTimePicker, {value: instance.data.value}, modalContentNode);
    },

    //when modal is closed
    complete: () => {

      //remove all content from the modal
      $(modalId).find('.modal-content').empty();
    }
  });
});

Template.materializeTimePickerModal.events({
  'click .js-materialize-time-picker-modal-clear': function(event, template){
    const instance = Template.instance();
    instance.data.value.set(undefined);
  }
});
